package org.jeecg.modules.stm.metric.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
 
 
import lombok.extern.slf4j.Slf4j;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.jeecg.common.system.base.controller.JeecgController;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.modules.stm.metric.service.IMetricApiReportService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;
import org.jeecg.modules.stm.metric.entity.MetricApiReport;

import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import java.util.Arrays;

 /**
 * @Description: 获取数据记录
 * @Author: jeecg-boot
 * @Date:   2023-12-17
 * @Version: V1.0
 */

@RestController
@RequestMapping("/metric/metricApiReport")
@Slf4j
public class MetricApiReportController extends JeecgController<MetricApiReport, IMetricApiReportService> {
	@Autowired
	private IMetricApiReportService metricApiReportService;
	
	/**
	 * 分页列表查询
	 *
	 * @param metricApiReport
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "获取数据记录-分页列表查询")

	@GetMapping(value = "/list")
	public Result<IPage<MetricApiReport>> queryPageList(MetricApiReport metricApiReport,
														@RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
														@RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
														HttpServletRequest req) {
		QueryWrapper<MetricApiReport> queryWrapper = QueryGenerator.initQueryWrapper(metricApiReport, req.getParameterMap());
		Page<MetricApiReport> page = new Page<MetricApiReport>(pageNo, pageSize);
		IPage<MetricApiReport> pageList = metricApiReportService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param metricApiReport
	 * @return
	 */
	@AutoLog(value = "获取数据记录-添加")

	@RequiresPermissions("metric:metric_api_report:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody MetricApiReport metricApiReport) {
		metricApiReportService.save(metricApiReport);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param metricApiReport
	 * @return
	 */
	@AutoLog(value = "获取数据记录-编辑")

	@RequiresPermissions("metric:metric_api_report:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody MetricApiReport metricApiReport) {
		metricApiReportService.updateById(metricApiReport);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "获取数据记录-通过id删除")

	@RequiresPermissions("metric:metric_api_report:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		metricApiReportService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "获取数据记录-批量删除")

	@RequiresPermissions("metric:metric_api_report:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.metricApiReportService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "获取数据记录-通过id查询")

	@GetMapping(value = "/queryById")
	public Result<MetricApiReport> queryById(@RequestParam(name="id",required=true) String id) {
		MetricApiReport metricApiReport = metricApiReportService.getById(id);
		if(metricApiReport==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(metricApiReport);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param metricApiReport
    */
    @RequiresPermissions("metric:metric_api_report:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, MetricApiReport metricApiReport) {
        return super.exportXls(request, metricApiReport, MetricApiReport.class, "获取数据记录");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("metric:metric_api_report:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, MetricApiReport.class);
    }

}
